---
title: FileReaderSync
slug: Web/API/FileReaderSync
tags:
  - API
  - NeedsMarkupWork
---
<div>{{APIRef("File API")}}</div>

<p><span class="seoSummary">The <code>FileReaderSync</code> interface allows to read {{DOMxRef("File")}} or {{DOMxRef("Blob")}} objects synchronously.</span></p>

<p>{{AvailableInWorkers}}</p>

<div class="notecard warning">
<p>This interface is <strong>only available</strong> in <a href="/en/DOM/Worker" title="Worker">workers</a> as it enables synchronous I/O that could potentially block.</p>
</div>

<h2 id="Method_overview">Properties</h2>

<p>This interface does not have any properties.</p>

<h2 id="Method_overview">Methods</h2>

<dl>
 <dt>{{DOMxRef("FileReaderSync.readAsArrayBuffer","FileReaderSync.readAsArrayBuffer()")}}</dt>
 <dd>This method converts a specified {{DOMxRef("Blob")}} or a {{DOMxRef("File")}} into an {{DOMxRef("ArrayBuffer")}} representing the input data as a binary string.</dd>
 <dt>{{DOMxRef("FileReaderSync.readAsBinaryString","FileReaderSync.readAsBinaryString()")}} {{deprecated_inline()}}</dt>
 <dd>This method converts a specified {{DOMxRef("Blob")}} or a {{DOMxRef("File")}} into a {{DOMxRef("DOMString")}} representing the input data as a binary string. This method is deprecated, consider using <code>readAsArrayBuffer()</code> instead.</dd>
 <dt>{{DOMxRef("FileReaderSync.readAsText","FileReaderSync.readAsText()")}}</dt>
 <dd>This method converts a specified {{DOMxRef("Blob")}} or a {{DOMxRef("File")}} into a {{DOMxRef("DOMString")}} representing the input data as a text string. The optional <strong><code>encoding</code></strong> parameter indicates the encoding to be used (e.g., iso-8859-1 or UTF-8). If not present, the method will apply a detection algorithm for it.</dd>
 <dt>{{DOMxRef("FileReaderSync.readAsDataURL","FileReaderSync.readAsDataURL()")}}</dt>
 <dd>This method converts a specified {{DOMxRef("Blob")}} or a {{DOMxRef("File")}} into a {{DOMxRef("DOMString")}} representing the input data as a data URL.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("File API","#FileReaderSync","FileReaderSync")}}</td>
   <td>{{Spec2("File API")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.FileReaderSync")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("FileReader")}}</li>
 <li>{{DOMxRef("BlobBuilder")}}, {{DOMxRef("Blob")}}</li>
 <li>{{DOMxRef("File")}}</li>
 <li>{{DOMxRef("FileReader")}}</li>
</ul>
